"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Server = void 0;
var react_1 = __importDefault(require("react"));
var fullstack_1 = require("@react-fullstack/fullstack");
var socket_io_1 = __importDefault(require("socket.io"));
/**
 * "@react-fullstack/fullstack" socket server
 */
var Server = /** @class */ (function (_super) {
    __extends(Server, _super);
    function Server(props) {
        var _this = _super.call(this, props) || this;
        _this.state = { apps: {} };
        _this.componentDidMount = function () {
            _this.server.sockets.setMaxListeners(0);
            _this.server.on("connection", function (socket) {
                if (_this.props.singleInstance) {
                    if (_this.mainAppRef) {
                        socket.setMaxListeners(0);
                        _this.mainAppRef.addClient(socket);
                        socket.on("disconnect", function () {
                            if (_this.mainAppRef) {
                                _this.mainAppRef.removeClient(socket);
                            }
                        });
                    }
                }
                else {
                    var id_1 = socket.id;
                    _this.state.apps[id_1] = socket;
                    _this.forceUpdate();
                    socket.on("disconnect", function () {
                        delete _this.state.apps[id_1];
                        _this.forceUpdate();
                    });
                }
            });
            _this.server.listen(_this.props.port);
        };
        _this.componentWillUnmount = function () {
            if (_this.server)
                _this.server.close();
        };
        _this.render = function () { return (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(fullstack_1.App, { ref: function (app) { _this.mainAppRef = app || undefined; }, children: _this.props.children, paused: !_this.props.singleInstance, views: _this.props.views, transportIsClient: false, transport: _this.server.sockets }),
            Object.entries(_this.state.apps).map(function (_a) {
                var id = _a[0], socket = _a[1];
                return (react_1.default.createElement(fullstack_1.App, { key: id, paused: false, transportIsClient: true, children: _this.props.children, views: _this.props.views, transport: socket }));
            }))); };
        _this.server = new socket_io_1.default.Server(_this.props.socketOptions);
        return _this;
    }
    return Server;
}(react_1.default.Component));
exports.Server = Server;
//# sourceMappingURL=index.js.map